# coding=utf-8
# --------------------------------------------------------------------------
# Copyright (c) Microsoft Corporation. All rights reserved.
# Licensed under the MIT License. See License.txt in the project root for
# license information.
#
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.
# --------------------------------------------------------------------------

from msrest.serialization import Model


class ImportRDBParameters(Model):
    """Parameters for Redis import operation.

    All required parameters must be populated in order to send to Azure.

    :param format: File format.
    :type format: str
    :param files: Required. files to import.
    :type files: list[str]
    """

    _validation = {
        'files': {'required': True},
    }

    _attribute_map = {
        'format': {'key': 'format', 'type': 'str'},
        'files': {'key': 'files', 'type': '[str]'},
    }

    def __init__(self, *, files, format: str=None, **kwargs) -> None:
        super(ImportRDBParameters, self).__init__(**kwargs)
        self.format = format
        self.files = files
